﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Tesis_V_6
{
    public partial class Gas : Form
    {
        public Gas()
        {
            InitializeComponent();
        }

        private void label8_Click(object sender, EventArgs e)
        {

        }

        private void label7_Click(object sender, EventArgs e)
        {

        }

        private void textBox4_TextChanged(object sender, EventArgs e)
        {

        }

        private void groupBox2_Enter(object sender, EventArgs e)
        {

        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }

        private void btnsalvar_Click(object sender, EventArgs e)
        {





            if (rbmedidas.Checked == true)
            {
                txtpresiongas.Enabled = false;
                txttempgas.Enabled = false;
                txtdensigas.Enabled = false;
                auxcapgas.metodo = "propmedidas";
                auxcapgas.gcm = double.Parse(txtgcm.Text);
                auxcapgas.viscm = double.Parse(txtviscm.Text);
                auxcapgas.densim = double.Parse(txtdensim.Text);
                

            }
            if (rbcorrelacion.Checked == true)
            {
                //desactiva las cajas de datos medidos//
                txtgcm.Enabled = false;
                txtviscm.Enabled = false;
                txtdensim.Enabled = false;


                auxcapgas.presiongas = double.Parse(txtpresiongas.Text);
                auxcapgas.tempgas = double.Parse(txttempgas.Text);
                auxcapgas.densigas = double.Parse(txtdensigas.Text);
                auxcapgas.metodo = "propcorrelacion";

                switch (combogas.SelectedIndex)
                {
                    case 0:
                        auxcapgas.corre = "brownnt";
                        break;

                    case 1:
                        auxcapgas.corre = "browngc";
                        break;

                    case 2:
                        auxcapgas.corre = "sutton";
                        break;
                }
                
            }

            //pseudopressure

            pseudopressure pseudopressure = new pseudopressure();
            
            int contpressure = -1;
             double delta = 15;

              for (double i = 14.7; i <= auxcap.pi + 14.7; i +=15)
            {
                contpressure = contpressure + 1;
                pseudopressure.presionmedida[contpressure]=i;
                pseudopressure.zeta[contpressure] = propdelgas.ztest(2, pseudopressure.presionmedida[contpressure],auxcap.t,auxcapgas.densim);
                pseudopressure.viscosidad[contpressure] = propdelgas.MLee(pseudopressure.presionmedida[contpressure], auxcap.t, auxcapgas.densim, pseudopressure.zeta[contpressure]);

                if (contpressure == 0)
                {
                    pseudopressure.mp[contpressure] = (pseudopressure.presionmedida[contpressure] * delta) / (pseudopressure.zeta[contpressure] * pseudopressure.viscosidad[contpressure] * 1000000);
                }
                else
                {
                    pseudopressure.mp[contpressure] = pseudopressure.mp[contpressure - 1] + ((((2* pseudopressure.presionmedida[contpressure]/(pseudopressure.viscosidad[contpressure]*pseudopressure.zeta[contpressure])) +(2*pseudopressure.presionmedida[contpressure-1]/(pseudopressure.viscosidad[contpressure-1]*pseudopressure.zeta[contpressure-1])))*(delta/2))/(1000000));
                }
                
            }

              

            int npesudopressure;
            npesudopressure = contpressure+1;
            splinecubico splinecubico = new splinecubico();
            splinecubico.x = new double[npesudopressure];
            splinecubico.y = new double[npesudopressure];

            for (int j = 0; j <= npesudopressure-1; j++)
            {
                splinecubico.x[j] = pseudopressure.presionmedida[j];
                splinecubico.y[j] = pseudopressure.mp[j];

            }

            int cont6 = 0;
            double ctegas= 1000000 * auxcapgas.viscm * pseudopressure.zeta[contpressure] / (auxcap.pi * 2);

            for (int j = 0; j < auxiliar.n;  j++)// GRAFICA LOS RESULTADOS
            {
                cont6 = cont6 + 1;
                //pseudopressure.deltas[cont6]= (pseudopressure.mp[npesudopressure] - splinecubico.spline(npesudopressure, auxiliar.presiones[j]))*1000000*auxcapgas.viscm*pseudopressure.zeta[npesudopressure]/(auxcap.pi*2);

                pseudopressure.deltas[j] =ctegas* (pseudopressure.mp[contpressure] - splinecubico.spline(npesudopressure, auxiliar.presiones[j]));


                //MessageBox.Show("tus datos", Convert.ToString(pseudopressure.deltas[j]));
            }

            


                Close();
        }

        private void label14_Click(object sender, EventArgs e)
        {

        }

        private void combogas_SelectedIndexChanged(object sender, EventArgs e)
        {

        }
    }
}
